package edu.stanford.nlp.ie.machinereading.domains.bionlp;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.Collection;

import edu.stanford.nlp.ling.StringLabelFactory;
import edu.stanford.nlp.trees.GrammaticalStructure;
import edu.stanford.nlp.trees.GrammaticalStructureFactory;
import edu.stanford.nlp.trees.LabeledScoredTreeFactory;
import edu.stanford.nlp.trees.PennTreeReader;
import edu.stanford.nlp.trees.PennTreebankLanguagePack;
import edu.stanford.nlp.trees.Tree;
import edu.stanford.nlp.trees.TreebankLanguagePack;
import edu.stanford.nlp.trees.TypedDependency;

/**
 * Prints Stanford dependencies for a given Tree
 * Useful for debugging
 */
public class ShowStanfordDependencies {
  public static void main(String[] args) throws Exception {
    TreebankLanguagePack tlp = new PennTreebankLanguagePack();
    GrammaticalStructureFactory gsf = tlp.grammaticalStructureFactory();
    BufferedReader is = new BufferedReader(new InputStreamReader(System.in));
    String line;
    while((line = is.readLine()) != null){
      Tree tree = (new PennTreeReader(new StringReader(line), new LabeledScoredTreeFactory(new StringLabelFactory()))).readTree();
      GrammaticalStructure gs = gsf.newGrammaticalStructure(tree);
      Collection<TypedDependency> deps = gs.typedDependenciesCCprocessed(false);
      System.out.println(deps);
      System.out.println();
    }
  }
}
